#!/bin/bash

echo "Compiling slotsig bench..."
g++ -O2 -Wall -o slotsig_m2o.x ../slotsig/slotsig_bases.cpp slotsig_m2o.cpp -lstdc++
g++ -O2 -Wall -o slotsig_o2m.x ../slotsig/slotsig_bases.cpp slotsig_o2m.cpp -lstdc++

echo "Compiling qt bench..."
moc bench_qt.h > moc_bench_qt.cpp
g++ -O2 -Wall -o qt_o2m.x qt_o2m.cpp moc_bench_qt.cpp -lstdc++ -I$QTDIR/include -L$QTDIR/lib -lqt-mt
g++ -O2 -Wall -o qt_m2o.x qt_m2o.cpp moc_bench_qt.cpp -lstdc++ -I$QTDIR/include -L$QTDIR/lib -lqt-mt

echo "Compiling boost bench..."
g++ -O2 -Wall -o boost_o2m.x boost_o2m.cpp -lstdc++  -lboost_signals
g++ -O2 -Wall -o boost_m2o.x boost_m2o.cpp -lstdc++  -lboost_signals

echo "Compiling sigslot bench..."
g++ -O2 -Wall -o sigslot_o2m.x sigslot_o2m.cpp -lstdc++
g++ -O2 -Wall -o sigslot_m2o.x sigslot_m2o.cpp -lstdc++

echo "Compiling slotsig non-unique bench..."
g++ -O2 -Wall -o slotsig_nonunique_m2o.x ../slotsig/slotsig_bases.cpp slotsig_nonunique_m2o.cpp -lstdc++
g++ -O2 -Wall -o slotsig_nonunique_o2m.x ../slotsig/slotsig_bases.cpp slotsig_nonunique_o2m.cpp -lstdc++

s="_"
for prg in slotsig qt boost sigslot slotsig_nonunique; do
  for what in m2o o2m; do
    echo "Running $prg, $what"
    echo "# nb, conn/sec, mem allocated, calls/sec, disconn/sec, mem freed" > $prg$s$what.txt
    i="100"
    while [ $i -lt 10000 ];
    do
      ./$prg$s$what.x $i  >> $prg$s$what.txt
      i=$((i+100))
    done
  done
done
