
// Compile command :
// g++ -Wall -o test_12.x -I.. -lstdc++ ../slotsig/slotsig_bases.cpp test_12.cpp
#include <iostream>
#include <string>
#include <slotsig/slotsig_12.h>

class C1 : public SlotSig::SlotsSetBase
{
  public:
    C1() : SlotSig::SlotsSetBase() { }

    std::string m1(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11)
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
      std::cout << "C1::m1 (" << s << ")\n" ;
      return "C1::m1" ;
    }

    std::string m2(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11) const
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
      std::cout << "C1::m2 (" << s << ")\n" ;
      return "C1::m2" ;
    }

    virtual std::string vm1(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11)
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
      std::cout << "C1::vm1 (" << s << ")\n" ;
      return "C1::vm1" ;
    }

    virtual std::string vm2(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11) const
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
      std::cout << "C1::vm2 (" << s << ")\n" ;
      return "C1::vm2" ;
    }
} ; // C1

class C2 : public C1
{
  public:
    C2() : C1() { }

    virtual std::string vm1(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11)
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
      std::cout << "C2::vm1 (" << s << ")\n" ;
      return "C2::vm1" ;
    }

    virtual std::string vm2(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11) const
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
      std::cout << "C2::vm2 (" << s << ")\n" ;
      return "C2::vm2" ;
    }
} ; // C2

std::string global_slot(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6, const std::string& s7, const std::string& s8, const std::string& s9, const std::string& s10, const std::string& s11)
{
  std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 + ", " + s7 + ", " + s8 + ", " + s9 + ", " + s10 + ", " + s11 ;
  std::cout << "::global_slot (" << s << ")\n" ;
  return "::global_slot" ;
}

struct Accum
{
  Accum() : str("") { }

  void operator() (const std::string& s)
  { str += (s + " ") ; }

  std::string str ;
} ; // Accum

struct Pred
{
  Pred() : cpt(0) { }

  bool operator() (const std::string&)
  { return ( ((++cpt) % 3) != 0 ) ; }

  unsigned cpt ;
} ; // Pred

int main()
{
  std::cout << "--- Test program START ---\n" ;

  C1* c1 = new C1 ;
  C2* c2 = new C2 ;
  typedef SlotSig::Sig12<std::string, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&> SigType ;
  SigType* sig1 = new SigType(false) ;
  SigType* sig2 = new SigType ;
  Accum accum ;
  Pred pred ;

  std::cout << "--- Connecting all methods from c1 to sig1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (global_slot)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::vm1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::vm2)) << "\n" ;
  std::cout << "--- Emitting sig1 #1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e1_0", "e1_1", "e1_2", "e1_3", "e1_4", "e1_5", "e1_6", "e1_7", "e1_8", "e1_9", "e1_10", "e1_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #2 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e2_0", "e2_1", "e2_2", "e2_3", "e2_4", "e2_5", "e2_6", "e2_7", "e2_8", "e2_9", "e2_10", "e2_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #3 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e3_0", "e3_1", "e3_2", "e3_3", "e3_4", "e3_5", "e3_6", "e3_7", "e3_8", "e3_9", "e3_10", "e3_11")) << "\n" ;

  std::cout << "--- Re-connecting all methods from c1 to sig1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (global_slot)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::vm1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c1, &C1::vm2)) << "\n" ;
  std::cout << "--- Emitting sig1 #4...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e4_0", "e4_1", "e4_2", "e4_3", "e4_4", "e4_5", "e4_6", "e4_7", "e4_8", "e4_9", "e4_10", "e4_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #5 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e5_0", "e5_1", "e5_2", "e5_3", "e5_4", "e5_5", "e5_6", "e5_7", "e5_8", "e5_9", "e5_10", "e5_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #6 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e6_0", "e6_1", "e6_2", "e6_3", "e6_4", "e6_5", "e6_6", "e6_7", "e6_8", "e6_9", "e6_10", "e6_11")) << "\n" ;

  std::cout << "--- Ensuring uniqueness of slots in sig1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->set_ensure_unique(true)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->enforce_unique()) << "\n" ;
  std::cout << "--- Emitting sig1 #7...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e7_0", "e7_1", "e7_2", "e7_3", "e7_4", "e7_5", "e7_6", "e7_7", "e7_8", "e7_9", "e7_10", "e7_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #8 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e8_0", "e8_1", "e8_2", "e8_3", "e8_4", "e8_5", "e8_6", "e8_7", "e8_8", "e8_9", "e8_10", "e8_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #9 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e9_0", "e9_1", "e9_2", "e9_3", "e9_4", "e9_5", "e9_6", "e9_7", "e9_8", "e9_9", "e9_10", "e9_11")) << "\n" ;

  std::cout << "--- Connecting all methods from c2 to sig1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::vm1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::vm2)) << "\n" ;
  std::cout << "--- Emitting sig1 #10...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e10_0", "e10_1", "e10_2", "e10_3", "e10_4", "e10_5", "e10_6", "e10_7", "e10_8", "e10_9", "e10_10", "e10_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #11 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e11_0", "e11_1", "e11_2", "e11_3", "e11_4", "e11_5", "e11_6", "e11_7", "e11_8", "e11_9", "e11_10", "e11_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #12 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e12_0", "e12_1", "e12_2", "e12_3", "e12_4", "e12_5", "e12_6", "e12_7", "e12_8", "e12_9", "e12_10", "e12_11")) << "\n" ;

  std::cout << "--- Re-connecting all methods from c2 to sig1...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::vm1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->connect (c2, &C2::vm2)) << "\n" ;
  std::cout << "--- Emitting sig1 #13...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e13_0", "e13_1", "e13_2", "e13_3", "e13_4", "e13_5", "e13_6", "e13_7", "e13_8", "e13_9", "e13_10", "e13_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #14 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e14_0", "e14_1", "e14_2", "e14_3", "e14_4", "e14_5", "e14_6", "e14_7", "e14_8", "e14_9", "e14_10", "e14_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #15 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e15_0", "e15_1", "e15_2", "e15_3", "e15_4", "e15_5", "e15_6", "e15_7", "e15_8", "e15_9", "e15_10", "e15_11")) << "\n" ;

  std::cout << "--- Connecting all methods from c1 and c2 to sig2...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (global_slot)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c1, &C1::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c1, &C1::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c1, &C1::vm1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c1, &C1::vm2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c2, &C2::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c2, &C2::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c2, &C2::vm1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->connect (c2, &C2::vm2)) << "\n" ;
  std::cout << "--- Emitting sig2 #16...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e16_0", "e16_1", "e16_2", "e16_3", "e16_4", "e16_5", "e16_6", "e16_7", "e16_8", "e16_9", "e16_10", "e16_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #17 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig2->run(accum, "e17_0", "e17_1", "e17_2", "e17_3", "e17_4", "e17_5", "e17_6", "e17_7", "e17_8", "e17_9", "e17_10", "e17_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig2 #18 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run_if(pred, "e18_0", "e18_1", "e18_2", "e18_3", "e18_4", "e18_5", "e18_6", "e18_7", "e18_8", "e18_9", "e18_10", "e18_11")) << "\n" ;

  std::cout << "--- Disconnecting global_slot, c1->m1, c1->vm2, c2->m2 and c2->vm1 from sig2...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->disconnect(global_slot)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->disconnect(c1, &C1::m1)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->disconnect(c1, &C1::vm2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->disconnect(c2, &C2::m2)) << "\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->disconnect(c2, &C2::vm1)) << "\n" ;
  std::cout << "--- Emitting sig1 #19...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e19_0", "e19_1", "e19_2", "e19_3", "e19_4", "e19_5", "e19_6", "e19_7", "e19_8", "e19_9", "e19_10", "e19_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #20 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e20_0", "e20_1", "e20_2", "e20_3", "e20_4", "e20_5", "e20_6", "e20_7", "e20_8", "e20_9", "e20_10", "e20_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #21 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e21_0", "e21_1", "e21_2", "e21_3", "e21_4", "e21_5", "e21_6", "e21_7", "e21_8", "e21_9", "e21_10", "e21_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #22...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e22_0", "e22_1", "e22_2", "e22_3", "e22_4", "e22_5", "e22_6", "e22_7", "e22_8", "e22_9", "e22_10", "e22_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #23 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig2->run(accum, "e23_0", "e23_1", "e23_2", "e23_3", "e23_4", "e23_5", "e23_6", "e23_7", "e23_8", "e23_9", "e23_10", "e23_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig2 #24 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run_if(pred, "e24_0", "e24_1", "e24_2", "e24_3", "e24_4", "e24_5", "e24_6", "e24_7", "e24_8", "e24_9", "e24_10", "e24_11")) << "\n" ;

  std::cout << "--- Deleting c1...\n" ;
  delete c1 ;
  c1 = 0 ;
  std::cout << "--- Emitting sig1 #25...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run("e25_0", "e25_1", "e25_2", "e25_3", "e25_4", "e25_5", "e25_6", "e25_7", "e25_8", "e25_9", "e25_10", "e25_11")) << "\n" ;
  std::cout << "--- Emitting sig1 #26 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig1->run(accum, "e26_0", "e26_1", "e26_2", "e26_3", "e26_4", "e26_5", "e26_6", "e26_7", "e26_8", "e26_9", "e26_10", "e26_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig1 #27 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig1->run_if(pred, "e27_0", "e27_1", "e27_2", "e27_3", "e27_4", "e27_5", "e27_6", "e27_7", "e27_8", "e27_9", "e27_10", "e27_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #28...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e28_0", "e28_1", "e28_2", "e28_3", "e28_4", "e28_5", "e28_6", "e28_7", "e28_8", "e28_9", "e28_10", "e28_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #29 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig2->run(accum, "e29_0", "e29_1", "e29_2", "e29_3", "e29_4", "e29_5", "e29_6", "e29_7", "e29_8", "e29_9", "e29_10", "e29_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig2 #30 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run_if(pred, "e30_0", "e30_1", "e30_2", "e30_3", "e30_4", "e30_5", "e30_6", "e30_7", "e30_8", "e30_9", "e30_10", "e30_11")) << "\n" ;

  std::cout << "--- Deleting sig1...\n" ;
  delete sig1 ;
  sig1 = 0 ;
  std::cout << "--- Emitting sig2 #31...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e31_0", "e31_1", "e31_2", "e31_3", "e31_4", "e31_5", "e31_6", "e31_7", "e31_8", "e31_9", "e31_10", "e31_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #32 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig2->run(accum, "e32_0", "e32_1", "e32_2", "e32_3", "e32_4", "e32_5", "e32_6", "e32_7", "e32_8", "e32_9", "e32_10", "e32_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig2 #33 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run_if(pred, "e33_0", "e33_1", "e33_2", "e33_3", "e33_4", "e33_5", "e33_6", "e33_7", "e33_8", "e33_9", "e33_10", "e33_11")) << "\n" ;

  std::cout << "--- Deleting c2...\n" ;
  delete c2 ;
  std::cout << "--- Emitting sig2 #34...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run("e34_0", "e34_1", "e34_2", "e34_3", "e34_4", "e34_5", "e34_6", "e34_7", "e34_8", "e34_9", "e34_10", "e34_11")) << "\n" ;
  std::cout << "--- Emitting sig2 #35 with accumulator...\n" ;
  accum.str = "" ;
  std::cout << "  " << SlotSig::error2str(sig2->run(accum, "e35_0", "e35_1", "e35_2", "e35_3", "e35_4", "e35_5", "e35_6", "e35_7", "e35_8", "e35_9", "e35_10", "e35_11")) << "\n" ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig2 #36 with predicate (run_if)...\n" ;
  std::cout << "  " << SlotSig::error2str(sig2->run_if(pred, "e36_0", "e36_1", "e36_2", "e36_3", "e36_4", "e36_5", "e36_6", "e36_7", "e36_8", "e36_9", "e36_10", "e36_11")) << "\n" ;

  std::cout << "--- Deleting sig2...\n" ;
  delete sig2 ;

  std::cout << "--- Test program END ----\n" ;
  return 0 ;
}
